
#ifndef _H_COMMAND_LINE_
#define _H_COMMAND_LINE_

#include <string>

#include "stdint.h"
#include "redkey.h"
#include "spice_configuration.h"

class CommandLine {
public:
    CommandLine(SpiceConfiguration& _spice_config);

    bool parse_cmd_line(int argc, const char** argv);
#ifdef WIN32
    bool parse_cmd_line(const char* cmdline);
#endif

    const std::string& get_host() { return _spice_config._host;}
    uint16_t get_port() { return _spice_config._port;}
    uint16_t get_sport() { return _spice_config._sport;}
    bool get_full_screen() { return _spice_config._full_screen;}
    bool get_no_audio() { return _spice_config._no_audio;}
    bool get_auto_res() { return _spice_config._auto_display_res;}
    const std::string& get_cipher() { return _spice_config._cipher;}
    const std::string& get_password() { return _spice_config._password;}
    const std::string& get_logger_ini() { return _spice_config._logger_ini;}
    void set_password(char* password) { _spice_config._password = password;}
    const bool *get_encrypted_channels() { return _spice_config._encrypt_channels;}
    SpiceConfiguration::hotkeys_t& get_hotkeys() { return _spice_config._hotkeys; }
    bool get_send_cad() { return _spice_config._send_cad; }
#ifdef WIN32
    bool get_no_taskmgr() { return _spice_config._no_taskmgr; }
#endif

private:
    bool parse_cmd_line(const std::vector<std::string>& args);

private:
    SpiceConfiguration& _spice_config;
};

#endif // _H_COMMAND_LINE_
