#ifndef _H_MONITOR
#define _H_MONITOR

#include "draw.h"

class Monitor {
public:
    Monitor(int id);

    int get_id() { return _id;}
    bool is_free() { return _free;}
    void set_free() {_free = true;}
    void set_used() {_free = false;}

    void set_mode(int width, int height);
    void restore();
    virtual int get_depth() = 0;
    virtual Point get_position() = 0;
    virtual Point get_size() const = 0;
    virtual bool is_out_of_sync() = 0;
    virtual int get_screen_id() = 0;

    static bool is_self_change();

protected:
    virtual ~Monitor() {}
    virtual void do_set_mode(int width, int height) = 0;
    virtual void do_restore() = 0;

private:
    int _id;
    bool _free;

protected:
    static uint32_t self_monitors_change;

    friend class Platform;
};

#endif

