#ifndef _H_RED_PIXMAP
#define _H_RED_PIXMAP

#include "red_drawable.h"

class RedPixmap : public RedDrawable {
public:
    enum Format {
        ARGB32,
        RGB32,
        A1,
    };

    RedPixmap(int width, int height, Format format, bool top_bottom,
              rgb32_t* pallete);
    virtual ~RedPixmap();

    virtual Point get_size() { Point pt = {_width, _height}; return pt;}

    int get_width() { return _width;}
    int get_height() { return _height;}
    int get_stride() { return _stride;}
    uint8_t* get_data() { return _data;}
    bool is_big_endian_bits();

protected:
    Format _format;
    int _width;
    int _height;
    int _stride;
    bool _top_bottom;
    uint8_t* _data;
};

#endif
