#ifndef _H_RED_TYPES
#define _H_RED_TYPES

#include <boost/thread/mutex.hpp>
#include <boost/thread/condition.hpp>

typedef boost::format fmt;
typedef boost::thread Thread;
typedef boost::mutex Mutex;
typedef boost::timed_mutex TimedMutex;
typedef boost::recursive_mutex RecurciveMutex;
typedef boost::condition Condition;

// Support for old boost::thread
#ifndef BOOST_THREAD_MUTEX_HPP
#include <boost/thread/detail/lock.hpp>
typedef boost::detail::thread::scoped_lock<Mutex> Lock;
typedef boost::detail::thread::scoped_timed_lock<TimedMutex> TimedLock;
typedef boost::detail::thread::scoped_lock<RecurciveMutex> RecurciveLock;
#else
typedef boost::mutex::scoped_lock Lock;
typedef boost::recursive_mutex::scoped_lock RecurciveLock;
#endif


struct PixmapHeader {
    uint8_t* data;
    int width;
    int height;
    int stride;
};

struct IconHeader {
    int width;
    int height;
    uint8_t* pixmap;
    uint8_t* mask;
};

class RedDrawable;

#ifdef WIN32
#define RedGLContext HGLRC
#else
#define RedGLContext GLXContext
#endif


#endif

