#ifndef _H_LINUX_PLAYBACK
#define _H_LINUX_PLAYBACK

#include <alsa/asoundlib.h>

#include "common.h"
#include "audio_devices.h"

class WavePlayer : public WavePlaybackAbstract {
public:
    WavePlayer(uint32_t sampels_per_sec, uint32_t bits_per_sample, uint32_t channels);
    virtual ~WavePlayer();
    
    virtual bool write(uint8_t* frame);
    virtual bool abort();
    virtual void stop();
    virtual uint32_t get_delay_ms();

private:
    bool init(uint32_t sampels_per_sec,uint32_t bits_per_sample, uint32_t channel);
    void cleanup();

private:
    snd_pcm_t* _pcm;
    snd_pcm_hw_params_t* _hw_params;
    snd_pcm_sw_params_t* _sw_params;
    uint32_t _sampels_per_ms;
};

#endif
